//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------
// game_menu.h

#define BLOODMENU_OFF     0
#define BLOODMENU_MAIN    1
#define BLOODMENU_QUIT    2
#define BLOODMENU_EPISODE 3
#define BLOODMENU_ESC     4 // calls main menu
#define BLOODMENU_DIFFUC  5
#define BLOODMENU_SAVEG   6
#define BLOODMENU_OPTIONS 7
#define BLOODMENU_VIDEO   8
#define BLOODMENU_MULTI   9
#define BLOODMENU_LOBBY   10
#define BLOODMENU_MJOIN   11
#define BLOODMENU_UMAPS   12
#define BLOODMENU_LOADING 13

struct bloodDrips
{
	int x;
	int y;
};

struct saveGame_t
{
	int  gameVersion;
	char gameName[20];
	int  numOfSprites;
	int  health;
	int  armor;
	int  currWeapon;

	saveGame_t::saveGame_t(char gameName[20], int numOfSprites, int health, int armor, 
							int currWeapon)
	{
		gameVersion  = 2;
		gameName     = gameName;
		numOfSprites = numOfSprites;
		health       = health;
		armor        = armor;
		currWeapon   = currWeapon;
	}
};
 
class gameMenu_t : public Game
{
	public:
		gameMenu_t();
		void DrawMenu(void);
		void SetMenu(int menuID);
		boolean MenuActive(void);
		void gameMenu_t::ChangeResolution(int resolution, int antistrophy, int fullscreen, 
								          int renderer);

		int pLevel;
		int pEpisode;
		int pDiffuculty;
	private:
		void menu_main(void);
		void menu_saveGame(void);
		void menu_quit(void);
		void menu_episode(void);
		void DrawBloodDrips(void);
		void DrawIcon(void);
		void FlushMenu(void);
		void ThisMenuMain(void);
		void menu_diffculty(void);
		void menu_options(void);
		void menu_video(void);
		void Menu_Multiplayer(void);
		void Menu_Lobby(void);
		void Lobby_PrintNames(void);
		void Menu_JoinGame(void);
		void Menu_UserMaps(void);

		static char *VideoTypes[];
		static char *resolution[];
		static char *mboolType[];
		static int  resWidth[];
		static int  resHeight[];
		static int  resBpp[];

		int  menuitems;
		int  slot;
		int  tmpNum;

		int lastMenu;

		boolean lastconnectfailed;
		boolean handleEscape;

		string usermapType;
		int fontNum;

		typedef void (gameMenu_t::*m_function)(void);

		struct menuItems_t
		{
			string name;
			int x;
			int y;
		};

		vector<string> lobbyUsers;

		menuItems_t *CreateBloodMenu(string name, void (gameMenu_t::*m_function)(void), int x, int y)
		{
			menuItems_t *thisMenu = new menuItems_t;

			thisMenu->name          = name;
		//	thisMenu->m_function    = m_function;
			thisMenu->x				= x;
			thisMenu->y				= y;

			thisMenuFunc.push_back(m_function);
			return thisMenu;
		}

		void AddItemToMenu(menuItems_t *thisItem);

		m_function thisFunc;

		vector<bloodDrips  *>       menuDrips;
		vector<menuItems_t *>       currentMenuItems;
		vector<m_function>			thisMenuFunc;
	protected:
		int currentMenu;
};

