//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//-------------------------------------------------------------------------

// game_precache.cpp

#include "game.h"

bloodsfx_t Game::RegisteredSFX[] = 
{ 
	// SOUNDNAME        FREQUENCEY   LOOPING    Volume
	{ "CULTFIR2.RAW"  , 11025 ,          0,        140}, // 0
	{ "SAW_COCK.RAW"  , 11025 ,          0,        140}, // 1
	{ "TOM_FIRE.RAW"  , 11025 ,          0,        140}, // 2
	{ "JUMP.RAW"      , 11025 ,          0,        140}, // 3
	{ "ISCREAM2.RAW"  , 11025 ,          0,        140}, // 4
	{ "AZOMDIE2.RAW"  , 11025 ,          0,        140}, // 5
	{ "SAW_FIR2.RAW"  , 11025 ,          0,        140}, // 6
	{ "SAW_FIR2.RAW"  , 11025 ,          0,        140}, // 7
	{ "CULTFIR2.RAW"  , 11025 ,          0,        140}, // 8
	{ "AZOMSPOT.RAW"  , 11025 ,          0,        140}, // 9
	{ "AZOMPAIN.RAW"  , 11025 ,          0,        140}, // 10
	{ "1107.RAW"      , 22050 ,          0,        140}, // 11
	{ "1010.RAW"      , 22050 ,          0,        140}, // 12
	{ "creakrot.raw"  , 11025 ,          0,        140}, // 13
	{ "drclos4.raw"   , 22050 ,          0,        140}, // 14
	{ "amb17.raw"     , 11025 ,          1,        60}, // 15
	{ "fire.raw"      , 11025 ,          1,        60}, // 16
	{ "2night.raw"    , 11025 ,          1,        50}, // 17
	{ "napalm.raw"    , 11025 ,          0,        100}, // 18
	{ "NAPLMEX2.RAW"  , 11025 ,          0,        160}, // 19
	
	// MOVE TO END
	{ "DOL_STAB.RAW"  , 11025 ,          0,        120}, // 20
	{ "AX_SWIPE.RAW"  , 11025 ,          0,        120}, // 21

	// End
	{ NULL            , -1    }
};

void Game::PrecacheSounds(void)
{
	int sndSfx = 0;
	while( 1 )
	{
		if(RegisteredSFX[sndSfx].frequency == -1)
			return;

		soundManager->precache_Sound(RegisteredSFX[sndSfx].soundName,RegisteredSFX[sndSfx].frequency,RegisteredSFX[sndSfx].looping,RegisteredSFX[sndSfx].volume);
		sndSfx++;
	}
}