//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------

// script_runner.h

struct variable_t
{
	char *name;
	char *val;

	variable_t::variable_t(char *name, char *val)
	{
		this->name = name;
		this->val  = val;
	}
};

class script_runner
{
	private:
		void    ReadComment(void);
		boolean CheckToken(char *tokenIn);
		void    CompileScript(char *progBuffer, int progSize);
		void    RunCodeBlock(int start, int end);
		void    ExecConditional(void);

		vector<int>          compiledProg;
		vector<variable_t *> scriptVariables;

		int  progEntry;
	    int  progEnd;
		int  currentPosition;
		int  compiled_position;
		int  playerspoted;
		int  oldhealth;

		static char *punctuation[];
		static char *events[];

		int thisRand;

		int thisReloadAmount;

		boolean leave_program;
	public:
		char        *thisProgBuffer;

		int thisHealth;
		int unfire;
		int spriteNum;

		script_runner::script_runner(string program)
		{
			this->program = program;
		}

		void Execute(void);
	private:
		string  program;
		int     readBytes;
		boolean gotoEndofScript;
		char    *token;
};